// generated from rosidl_generator_cpp/resource/idl__builder.hpp.em
// with input from rcgcd_spl_14:msg/RCGCD.idl
// generated code does not contain a copyright notice

#ifndef RCGCD_SPL_14__MSG__DETAIL__RCGCD__BUILDER_HPP_
#define RCGCD_SPL_14__MSG__DETAIL__RCGCD__BUILDER_HPP_

#include <algorithm>
#include <utility>

#include "rcgcd_spl_14/msg/detail/rcgcd__struct.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


namespace rcgcd_spl_14
{

namespace msg
{

namespace builder
{

class Init_RCGCD_teams
{
public:
  explicit Init_RCGCD_teams(::rcgcd_spl_14::msg::RCGCD & msg)
  : msg_(msg)
  {}
  ::rcgcd_spl_14::msg::RCGCD teams(::rcgcd_spl_14::msg::RCGCD::_teams_type arg)
  {
    msg_.teams = std::move(arg);
    return std::move(msg_);
  }

private:
  ::rcgcd_spl_14::msg::RCGCD msg_;
};

class Init_RCGCD_secondary_time
{
public:
  explicit Init_RCGCD_secondary_time(::rcgcd_spl_14::msg::RCGCD & msg)
  : msg_(msg)
  {}
  Init_RCGCD_teams secondary_time(::rcgcd_spl_14::msg::RCGCD::_secondary_time_type arg)
  {
    msg_.secondary_time = std::move(arg);
    return Init_RCGCD_teams(msg_);
  }

private:
  ::rcgcd_spl_14::msg::RCGCD msg_;
};

class Init_RCGCD_secs_remaining
{
public:
  explicit Init_RCGCD_secs_remaining(::rcgcd_spl_14::msg::RCGCD & msg)
  : msg_(msg)
  {}
  Init_RCGCD_secondary_time secs_remaining(::rcgcd_spl_14::msg::RCGCD::_secs_remaining_type arg)
  {
    msg_.secs_remaining = std::move(arg);
    return Init_RCGCD_secondary_time(msg_);
  }

private:
  ::rcgcd_spl_14::msg::RCGCD msg_;
};

class Init_RCGCD_kicking_team
{
public:
  explicit Init_RCGCD_kicking_team(::rcgcd_spl_14::msg::RCGCD & msg)
  : msg_(msg)
  {}
  Init_RCGCD_secs_remaining kicking_team(::rcgcd_spl_14::msg::RCGCD::_kicking_team_type arg)
  {
    msg_.kicking_team = std::move(arg);
    return Init_RCGCD_secs_remaining(msg_);
  }

private:
  ::rcgcd_spl_14::msg::RCGCD msg_;
};

class Init_RCGCD_first_half
{
public:
  explicit Init_RCGCD_first_half(::rcgcd_spl_14::msg::RCGCD & msg)
  : msg_(msg)
  {}
  Init_RCGCD_kicking_team first_half(::rcgcd_spl_14::msg::RCGCD::_first_half_type arg)
  {
    msg_.first_half = std::move(arg);
    return Init_RCGCD_kicking_team(msg_);
  }

private:
  ::rcgcd_spl_14::msg::RCGCD msg_;
};

class Init_RCGCD_set_play
{
public:
  explicit Init_RCGCD_set_play(::rcgcd_spl_14::msg::RCGCD & msg)
  : msg_(msg)
  {}
  Init_RCGCD_first_half set_play(::rcgcd_spl_14::msg::RCGCD::_set_play_type arg)
  {
    msg_.set_play = std::move(arg);
    return Init_RCGCD_first_half(msg_);
  }

private:
  ::rcgcd_spl_14::msg::RCGCD msg_;
};

class Init_RCGCD_state
{
public:
  explicit Init_RCGCD_state(::rcgcd_spl_14::msg::RCGCD & msg)
  : msg_(msg)
  {}
  Init_RCGCD_set_play state(::rcgcd_spl_14::msg::RCGCD::_state_type arg)
  {
    msg_.state = std::move(arg);
    return Init_RCGCD_set_play(msg_);
  }

private:
  ::rcgcd_spl_14::msg::RCGCD msg_;
};

class Init_RCGCD_game_phase
{
public:
  explicit Init_RCGCD_game_phase(::rcgcd_spl_14::msg::RCGCD & msg)
  : msg_(msg)
  {}
  Init_RCGCD_state game_phase(::rcgcd_spl_14::msg::RCGCD::_game_phase_type arg)
  {
    msg_.game_phase = std::move(arg);
    return Init_RCGCD_state(msg_);
  }

private:
  ::rcgcd_spl_14::msg::RCGCD msg_;
};

class Init_RCGCD_competition_type
{
public:
  explicit Init_RCGCD_competition_type(::rcgcd_spl_14::msg::RCGCD & msg)
  : msg_(msg)
  {}
  Init_RCGCD_game_phase competition_type(::rcgcd_spl_14::msg::RCGCD::_competition_type_type arg)
  {
    msg_.competition_type = std::move(arg);
    return Init_RCGCD_game_phase(msg_);
  }

private:
  ::rcgcd_spl_14::msg::RCGCD msg_;
};

class Init_RCGCD_competition_phase
{
public:
  explicit Init_RCGCD_competition_phase(::rcgcd_spl_14::msg::RCGCD & msg)
  : msg_(msg)
  {}
  Init_RCGCD_competition_type competition_phase(::rcgcd_spl_14::msg::RCGCD::_competition_phase_type arg)
  {
    msg_.competition_phase = std::move(arg);
    return Init_RCGCD_competition_type(msg_);
  }

private:
  ::rcgcd_spl_14::msg::RCGCD msg_;
};

class Init_RCGCD_players_per_team
{
public:
  explicit Init_RCGCD_players_per_team(::rcgcd_spl_14::msg::RCGCD & msg)
  : msg_(msg)
  {}
  Init_RCGCD_competition_phase players_per_team(::rcgcd_spl_14::msg::RCGCD::_players_per_team_type arg)
  {
    msg_.players_per_team = std::move(arg);
    return Init_RCGCD_competition_phase(msg_);
  }

private:
  ::rcgcd_spl_14::msg::RCGCD msg_;
};

class Init_RCGCD_packet_number
{
public:
  Init_RCGCD_packet_number()
  : msg_(::rosidl_runtime_cpp::MessageInitialization::SKIP)
  {}
  Init_RCGCD_players_per_team packet_number(::rcgcd_spl_14::msg::RCGCD::_packet_number_type arg)
  {
    msg_.packet_number = std::move(arg);
    return Init_RCGCD_players_per_team(msg_);
  }

private:
  ::rcgcd_spl_14::msg::RCGCD msg_;
};

}  // namespace builder

}  // namespace msg

template<typename MessageType>
auto build();

template<>
inline
auto build<::rcgcd_spl_14::msg::RCGCD>()
{
  return rcgcd_spl_14::msg::builder::Init_RCGCD_packet_number();
}

}  // namespace rcgcd_spl_14

#endif  // RCGCD_SPL_14__MSG__DETAIL__RCGCD__BUILDER_HPP_
